export declare const enum Token {
    Type = 255,
    PrecStart = 8,
    Precedence = 3840,
    Keyword = 4096,
    Contextual = 12288,
    Reserved = 20480,
    FutureReserved = 36864,
    IsExpressionStart = 65536,
    IsIdentifier = 143360,
    IsInOrOf = 262144,
    IsLogical = 524288,
    IsAutoSemicolon = 1048576,
    IsPatternStart = 2097152,
    IsAssignOp = 4194304,
    IsBinaryOp = 8454144,
    IsUnaryOp = 16842752,
    IsUpdateOp = 33619968,
    IsMemberOrCallExpression = 67108864,
    IsStringOrNumber = 134217728,
    IsCoalesc = 268435456,
    IsEvalOrArguments = 537079808,
    IsClassField = 1073741824,
    EOF = 1048576,
    Identifier = 208897,
    NumericLiteral = 134283266,
    StringLiteral = 134283267,
    RegularExpression = 65540,
    FalseKeyword = 86021,
    TrueKeyword = 86022,
    NullKeyword = 86023,
    TemplateContinuation = 67174408,
    TemplateSpan = 67174409,
    Arrow = 10,
    LeftParen = 67174411,
    LeftBrace = 2162700,
    Period = 67108877,
    Ellipsis = 14,
    RightBrace = 1074790415,
    RightParen = 16,
    Semicolon = 1074790417,
    Comma = 18,
    LeftBracket = 69271571,
    RightBracket = 20,
    Colon = 21,
    QuestionMark = 22,
    SingleQuote = 23,
    DoubleQuote = 24,
    JSXClose = 25,
    JSXAutoClose = 26,
    Increment = 33619995,
    Decrement = 33619996,
    Assign = 1077936157,
    ShiftLeftAssign = 4194334,
    ShiftRightAssign = 4194335,
    LogicalShiftRightAssign = 4194336,
    ExponentiateAssign = 4194337,
    AddAssign = 4194338,
    SubtractAssign = 4194339,
    MultiplyAssign = 4194340,
    DivideAssign = 4259877,
    ModuloAssign = 4194342,
    BitwiseXorAssign = 4194343,
    BitwiseOrAssign = 4194344,
    BitwiseAndAssign = 4194345,
    TypeofKeyword = 16863274,
    DeleteKeyword = 16863275,
    VoidKeyword = 16863276,
    Negate = 16842797,
    Complement = 16842798,
    Add = 25233967,
    Subtract = 25233968,
    InKeyword = 8738865,
    InstanceofKeyword = 8476722,
    Multiply = 8457011,
    Modulo = 8457012,
    Divide = 8457013,
    Exponentiate = 8457270,
    LogicalAnd = 8979255,
    LogicalOr = 8979000,
    StrictEqual = 8455993,
    StrictNotEqual = 8455994,
    LooseEqual = 8455995,
    LooseNotEqual = 8455996,
    LessThanOrEqual = 8455997,
    GreaterThanOrEqual = 8455998,
    LessThan = 8456255,
    GreaterThan = 8456256,
    ShiftLeft = 8456513,
    ShiftRight = 8456514,
    LogicalShiftRight = 8456515,
    BitwiseAnd = 8455748,
    BitwiseOr = 8455237,
    BitwiseXor = 8455494,
    VarKeyword = 86087,
    LetKeyword = 241736,
    ConstKeyword = 86089,
    BreakKeyword = 20554,
    CaseKeyword = 20555,
    CatchKeyword = 20556,
    ClassKeyword = 86093,
    ContinueKeyword = 20558,
    DebuggerKeyword = 20559,
    DefaultKeyword = 20560,
    DoKeyword = 20561,
    ElseKeyword = 20562,
    ExportKeyword = 20563,
    ExtendsKeyword = 20564,
    FinallyKeyword = 20565,
    ForKeyword = 20566,
    FunctionKeyword = 86103,
    IfKeyword = 20568,
    ImportKeyword = 86105,
    NewKeyword = 86106,
    ReturnKeyword = 20571,
    SuperKeyword = 86108,
    SwitchKeyword = 86109,
    ThisKeyword = 86110,
    ThrowKeyword = 86111,
    TryKeyword = 20576,
    WhileKeyword = 20577,
    WithKeyword = 20578,
    ImplementsKeyword = 36963,
    InterfaceKeyword = 36964,
    PackageKeyword = 36965,
    PrivateKeyword = 36966,
    ProtectedKeyword = 36967,
    PublicKeyword = 36968,
    StaticKeyword = 36969,
    YieldKeyword = 241770,
    AsKeyword = 12395,
    AsyncKeyword = 143468,
    AwaitKeyword = 209005,
    ConstructorKeyword = 12398,
    GetKeyword = 12399,
    SetKeyword = 12400,
    FromKeyword = 12401,
    OfKeyword = 274546,
    EnumKeyword = 20595,
    Eval = 537079924,
    Arguments = 537079925,
    EscapedReserved = 118,
    EscapedFutureReserved = 119,
    AnyIdentifier = 143480,
    PrivateName = 121,
    BigIntLiteral = 134283386,
    Coalesce = 276889979,
    QuestionMarkPeriod = 67108988,
    WhiteSpace = 125,
    Illegal = 126,
    CarriageReturn = 127,
    PrivateField = 128,
    Template = 129,
    Decorator = 130,
    Target = 143491,
    Meta = 143492,
    LineFeed = 133,
    EscapedIdentifier = 134,
    JSXText = 135
}
export declare const KeywordDescTable: string[];
export declare const descKeywordTable: {
    [key: string]: Token;
};
//# sourceMappingURL=token.d.ts.map